//+------------------------------------------------------------------+
//|                                             eVOLution-levels.mq4 |
//|                Copyright  2010, someBody, trading-evolution.com |
//|                                 http://www.trading-evolution.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009-2010, someBody, trading-evolution.com"
#property link      "http://www.trading-evolution.com"

#property indicator_chart_window
#property indicator_buffers 11
#property indicator_style1    STYLE_DOT //  
#property indicator_style2    STYLE_DOT //  
#property indicator_style3    STYLE_DOT //  
#property indicator_style4    STYLE_DOT //  
#property indicator_style5    STYLE_DOT //  
#property indicator_style6    STYLE_DOT //  
#property indicator_style7    STYLE_DOT //  
#property indicator_style8    STYLE_DOT //  
#property indicator_style9    STYLE_DOT //  
#property indicator_style10    STYLE_DOT //  
#property indicator_style11    STYLE_DOT //  
#property indicator_style12    STYLE_DOT //  

#import

 int NumberOfDaysBackToShow = 20;
extern double LevelsVerticalShift = 0;
extern double EnterUP = 0.00040;
extern double EnterDw = 0.00020;
string FileNamePruductCode  = "";
 string separator = "-------------";
 bool HideForLongTimeframe = True;
 bool ReverseDataFromFile = False;
 bool ShowKeyZone = True;
 bool ShowMajorLevels = True;
 bool ShowMajorCALLLevels = True;
 bool ShowMajorPUTLevels = True;
 color KeyZonePositiveColor = SteelBlue;
 color KeyZoneNegativeColor = Yellow;
 color KeyZoneArrowColor = Black;
 color MajorCALLColor = Green;
 color MajorPUTColor = Red;
 color MajorLevelsColor = Black;
 int MajorCALLStyle=1;
 int MajorPUTStyle=1;

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Buffer8[];
double Buffer9[];
double Buffer10[];
double Buffer11[];
double Level1[];
double Level2;
double Level3;
double Level4;
double Level5;
double Level6;
double Level7;
double Level8;
double Level9;
double Level10;
datetime curDay;



int FirstLevelWidth=1;
int correction=1,b;

string varray[50];
string currency,currency1;
string curmonth,nextmonth,curdate,curyear,nextyear;
bool cur,reverse;
int clevel1count,clevel2count,arrowcode;
color KeyZoneColor;

//---- input parameters
int          corner=0;




double ExtMapBuffer1[];
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
    SetIndexBuffer(1,Buffer1,INDICATOR_DATA);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(2,Buffer2,INDICATOR_DATA);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(3,Buffer3,INDICATOR_DATA);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(4,Buffer4,INDICATOR_DATA);
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(5,Buffer5,INDICATOR_DATA);
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(6,Buffer6,INDICATOR_DATA);
   PlotIndexSetDouble(6,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(7,Buffer7,INDICATOR_DATA);
   PlotIndexSetDouble(7,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(8,Buffer8,INDICATOR_DATA);
   PlotIndexSetDouble(8,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(9,Buffer9,INDICATOR_DATA);
   PlotIndexSetDouble(9,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(10,Buffer10,INDICATOR_DATA);
   PlotIndexSetDouble(10,PLOT_EMPTY_VALUE,0.0);
   SetIndexBuffer(11,Buffer11,INDICATOR_DATA);
   PlotIndexSetDouble(11,PLOT_EMPTY_VALUE,0.0);
//---- checking if timeframe is begger than 1hour, if so - drow nothing
if (HideForLongTimeframe && Period()>60)
{
   return(0);
}

//---- indicators
   cur=TRUE;
   NumberOfDaysBackToShow=NumberOfDaysBackToShow+1;
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   

//---- trying to indentify what file to load based on symbol
   currency =StringSubstr( Symbol(),0,2);
   currency1 = StringSubstr( Symbol(),0,6);
   
   if(currency=="6E" || currency1=="EURUSD")
   {currency = "ec";
   reverse=false;}
   else if(currency =="6B" || currency1=="GBPUSD")
   {currency = "bp";
   reverse=false;}
   else if(currency=="6J")
   {currency ="jy";
   reverse=false;}
   else if (currency1=="USDJPY")
   {currency ="jy";
   reverse=true;
   correction=100;}
   else if(currency == "6A" || currency1 == "AUDUSD")
   {currency ="ad";
   reverse=false;}
   else if(currency=="GC" || currency1=="XAU")
   {currency = "gc";
   reverse=false;}
   else if(currency=="SI" || currency1=="XAG")
   {currency = "si";
   reverse=false;}
   else if(currency=="CL")
   {currency = "cl";
   reverse=false;}
   else if(currency == "6C")
   {currency ="cd";
   reverse=false;}
   else if (currency1 =="USDCAD")
   {currency ="cd";
   reverse=true;
   correction=1;}
   else if(currency =="ES" || currency1 =="S&P_50")
   {currency = "es";
   reverse=false;}
   else if(StringLen(FileNamePruductCode )>1)
   {currency = FileNamePruductCode ;
   cur=true;
      if (ReverseDataFromFile==true)reverse=true;
      else reverse = false;
   }
   else{cur=FALSE;return(0);}





Print ("symbol_code is "+currency);



if(cur==FALSE){Alert("Product not recognized.");return(0);}



//----
   string filename,filename2, buff_str = "";
   int shft, handle,handle2, height, pointer, j, m;
   shft=10;
   int weekendshift=0;






for (j=0;j<NumberOfDaysBackToShow;j++)
{
m=TimeCurrent()-86400*j-86400*weekendshift;
//---- getting date data


if (TimeDayOfWeek(m)==0)
{weekendshift=2;
m=TimeCurrent()-86400*j-86400*weekendshift;}

else if (TimeDayOfWeek(m)==6)
{weekendshift=1;
m=TimeCurrent()-86400*j-86400*weekendshift;
}


if (TimeDay(m)<10){
curdate="0"+TimeDay(m);
}
else
{
curdate=TimeDay(m);
}

curyear=TimeYear(m);
nextyear=curyear;

if (TimeMonth(m)<10)
{curmonth="0"+TimeMonth(m);}
else
{curmonth=TimeMonth(m);}

if (TimeMonth(m)<=8)
{nextmonth="0"+(TimeMonth(m)+1);}
else if (TimeMonth(m)<12 && TimeMonth(m)>8)
{nextmonth=(TimeMonth(m)+1);}
else
{nextmonth="01";
nextyear=StrToInteger(curyear)+1;
}

curyear=StringSubstr(curyear,2,2);
nextyear=StringSubstr(nextyear,2,2);


//---- loading file

   filename = "/evolution-options/ol-"+curyear+curmonth+curdate+"-"+currency+"-"+curyear+curmonth+".csv";
   Print ("---> Filename "+filename);
   handle=FileOpen(filename, FILE_CSV|FILE_READ,",");
   
   //current month file opening problem
   if(handle<0)    
      {
      if(GetLastError()==4103)         
         {
         Print("No such file "+filename+" , trying next month contract period");
         filename = "/evolution-options/ol-"+curyear+curmonth+curdate+"-"+currency+"-"+nextyear+nextmonth+".csv";
         handle=FileOpen(filename, FILE_CSV|FILE_READ,",");
         Print (filename);
         
         
         //next month file opening problem
         if(handle<0)
            {
            if(GetLastError()==4103)
               {
               //Print("No such file "+filename);
               continue;
               }
            else                         
               {Print("Error opening file ");}
            }
      }
      else                       
         {Print("Error opening file ");}
     }
     
    
    if (handle>0)
    {
    int i=0;
     while ( !FileIsEnding(handle))
      {
      varray[i] = FileReadString(handle);
      i++;
      }

      FileClose( handle );

//Level1[j]=StrToDouble(varray[5])+LevelsVerticalShift;
}
//      Level1[]
Level1[j]=StrToDouble(varray[5]);
//+LevelsVerticalShift;
//if (j==1){
//Level1[j]=StrToDouble(varray[5])+LevelsVerticalShift;
/*Level2=StrToDouble(varray[2])+LevelsVerticalShift;
Level3=StrToDouble(varray[3])+LevelsVerticalShift;
Level4=StrToDouble(varray[4])+LevelsVerticalShift;
Level5=StrToDouble(varray[5])+LevelsVerticalShift;
Level6=StrToDouble(varray[6])+LevelsVerticalShift;
Level7=StrToDouble(varray[7])+LevelsVerticalShift;
Level8=StrToDouble(varray[8])+LevelsVerticalShift;
Level9=StrToDouble(varray[9])+LevelsVerticalShift;
Level10=StrToDouble(varray[10])+LevelsVerticalShift;

//if (MathAbs(Level2-Level1[j])<0.00150){Level1[j]=Level1[j]-((Level1-Level2)/2);Level2=Level1;}
//}*/


Print ("Go for it "+varray[0]);

//---------------------------------------------------------------

if (!reverse){

   if (varray[1]<varray[2])
   KeyZoneColor=KeyZonePositiveColor;
   else
   KeyZoneColor=KeyZoneNegativeColor;}
else
{
   if (varray[1]<varray[2])
   KeyZoneColor=KeyZoneNegativeColor;
   else
   KeyZoneColor=KeyZonePositiveColor;
}

if (KeyZoneColor==KeyZonePositiveColor)
   arrowcode=241;
else
   arrowcode=242;
   


if (ShowKeyZone){
  drawArea("keyzone-"+j, varray[0] , StrToDouble(varray[1]) ,  StrToDouble(varray[2]), KeyZoneColor,0,0,FirstLevelWidth);

  }
  
if (ShowMajorLevels){
 // drawLine("major1-"+j, "nothing" , varray[0] , StrToDouble(varray[3]), MajorLevelsColor,0,0,FirstLevelWidth);
  drawLine("major2-"+j, "nothing" , varray[0] , StrToDouble(varray[4]), MajorLevelsColor,0,0,FirstLevelWidth);
  }
if (ShowMajorCALLLevels){
  drawLine("call1-"+j, "nothing" , varray[0] , StrToDouble(varray[5]), MajorCALLColor,MajorCALLStyle,0,FirstLevelWidth);
  drawLine("call2-"+j, "nothing" , varray[0] , StrToDouble(varray[6]), MajorCALLColor,MajorCALLStyle,0,FirstLevelWidth);
  drawLine("call3-"+j, "nothing" , varray[0] , StrToDouble(varray[7]), MajorCALLColor,MajorCALLStyle,0,FirstLevelWidth);
  }
if (ShowMajorPUTLevels){
  drawLine("put1-"+j, "nothing" , varray[0] , StrToDouble(varray[8]), MajorPUTColor,MajorPUTStyle,0,FirstLevelWidth);
  drawLine("put2-"+j, "nothing" , varray[0] , StrToDouble(varray[9]), MajorPUTColor,MajorPUTStyle,0,FirstLevelWidth);
  drawLine("put3-"+j, "nothing" , varray[0] , StrToDouble(varray[10]), MajorPUTColor,MajorPUTStyle,0,FirstLevelWidth);
  }


}
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  int k;
      
for (k=0;k<NumberOfDaysBackToShow;k++){   
   ObjectDelete("keyzone-"+k);
   ObjectDelete("keyzone-"+k+"arrow");
   ObjectDelete("major1-"+k);
   ObjectDelete("major2-"+k);
   ObjectDelete("call1-"+k);
   ObjectDelete("call2-"+k);
   ObjectDelete("call3-"+k);
   ObjectDelete("put1-"+k);
   ObjectDelete("put2-"+k);
   ObjectDelete("put3-"+k);
   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
 
  int i,limit,z,q,z1,q1,z2,q2,z3,q3,z4,q4;
  double qLevel1,qLevel2,qLevel3,qLevel4,qLevel5,qLevel6,qLevel7,qLevel8,qLevel9,qLevel10;
limit=Bars;
if (b!=Bars){
b=Bars;
 for(i=limit; i>=0; i--){  



if (curDay!=TimeDay(Time[i])) {
curDay=TimeDay(Time[i]);

qLevel1=Level1[5];      

}

    /*  if ((Close[i+5]>Level1)&&(Open[i+5]>Level1)&&(Close[i]>Level1)&&(Open[i]>Level1)&&(Close[i+1]>Level1)&&(Open[i+1]>Level1)&&(Close[i+2]>Level1)&&(Open[i+2]>Level1)&&(Close[i+3]>Level1)&&(Open[i+3]>Level1)&&(Close[i+4]>Level1)&&(Open[i+4]>Level1)) qLevel1=Level1+EnterUP;  
      if ((Close[i+5]<Level1)&&(Open[i+5]<Level1)&&(Close[i]<Level1)&&(Open[i]<Level1)&&(Close[i+1]<Level1)&&(Open[i+1]<Level1)&&(Close[i+2]<Level1)&&(Open[i+2]<Level1)&&(Close[i+3]<Level1)&&(Open[i+3]<Level1)&&(Close[i+4]<Level1)&&(Open[i+4]<Level1)) qLevel1=Level1-EnterDw;  
      if ((Close[i+5]>Level2)&&(Open[i+5]>Level2)&&(Close[i]>Level2)&&(Open[i]>Level2)&&(Close[i+1]>Level2)&&(Open[i+1]>Level2)&&(Close[i+2]>Level2)&&(Open[i+2]>Level2)&&(Close[i+3]>Level2)&&(Open[i+3]>Level2)&&(Close[i+4]>Level2)&&(Open[i+4]>Level2)) qLevel2=Level2+EnterUP;  
      if ((Close[i+5]<Level2)&&(Open[i+5]<Level2)&&(Close[i]<Level2)&&(Open[i]<Level2)&&(Close[i+1]<Level2)&&(Open[i+1]<Level2)&&(Close[i+2]<Level2)&&(Open[i+2]<Level2)&&(Close[i+3]<Level2)&&(Open[i+3]<Level2)&&(Close[i+4]<Level2)&&(Open[i+4]<Level2)) qLevel2=Level2-EnterDw;  
      if ((Close[i+5]>Level3)&&(Open[i+5]>Level3)&&(Close[i]>Level3)&&(Open[i]>Level3)&&(Close[i+1]>Level3)&&(Open[i+1]>Level3)&&(Close[i+2]>Level3)&&(Open[i+2]>Level3)&&(Close[i+3]>Level3)&&(Open[i+3]>Level3)&&(Close[i+4]>Level3)&&(Open[i+4]>Level3)) qLevel3=Level3+EnterUP;  
      if ((Close[i+5]<Level3)&&(Open[i+5]<Level3)&&(Close[i]<Level3)&&(Open[i]<Level3)&&(Close[i+1]<Level3)&&(Open[i+1]<Level3)&&(Close[i+2]<Level3)&&(Open[i+2]<Level3)&&(Close[i+3]<Level3)&&(Open[i+3]<Level3)&&(Close[i+4]<Level3)&&(Open[i+4]<Level3)) qLevel3=Level3-EnterDw;  
      if ((Close[i+5]>Level4)&&(Open[i+5]>Level4)&&(Close[i]>Level4)&&(Open[i]>Level4)&&(Close[i+1]>Level4)&&(Open[i+1]>Level4)&&(Close[i+2]>Level4)&&(Open[i+2]>Level4)&&(Close[i+3]>Level4)&&(Open[i+3]>Level4)&&(Close[i+4]>Level4)&&(Open[i+4]>Level4)) qLevel4=Level4+EnterUP;  
      if ((Close[i+5]<Level4)&&(Open[i+5]<Level4)&&(Close[i]<Level4)&&(Open[i]<Level4)&&(Close[i+1]<Level4)&&(Open[i+1]<Level4)&&(Close[i+2]<Level4)&&(Open[i+2]<Level4)&&(Close[i+3]<Level4)&&(Open[i+3]<Level4)&&(Close[i+4]<Level4)&&(Open[i+4]<Level4)) qLevel4=Level4-EnterDw;  
      if ((Close[i+5]>Level5)&&(Open[i+5]>Level5)&&(Close[i]>Level5)&&(Open[i]>Level5)&&(Close[i+1]>Level5)&&(Open[i+1]>Level5)&&(Close[i+2]>Level5)&&(Open[i+2]>Level5)&&(Close[i+3]>Level5)&&(Open[i+3]>Level5)&&(Close[i+4]>Level5)&&(Open[i+4]>Level5)) qLevel5=Level5+EnterUP;  
      if ((Close[i+5]<Level5)&&(Open[i+5]<Level5)&&(Close[i]<Level5)&&(Open[i]<Level5)&&(Close[i+1]<Level5)&&(Open[i+1]<Level5)&&(Close[i+2]<Level5)&&(Open[i+2]<Level5)&&(Close[i+3]<Level5)&&(Open[i+3]<Level5)&&(Close[i+4]<Level5)&&(Open[i+4]<Level5)) qLevel5=Level5-EnterDw;  
      if ((Close[i+5]>Level6)&&(Open[i+5]>Level6)&&(Close[i]>Level6)&&(Open[i]>Level6)&&(Close[i+1]>Level6)&&(Open[i+1]>Level6)&&(Close[i+2]>Level6)&&(Open[i+2]>Level6)&&(Close[i+3]>Level6)&&(Open[i+3]>Level6)&&(Close[i+4]>Level6)&&(Open[i+4]>Level6)) qLevel6=Level6+EnterUP;  
      if ((Close[i+5]<Level6)&&(Open[i+5]<Level6)&&(Close[i]<Level6)&&(Open[i]<Level6)&&(Close[i+1]<Level6)&&(Open[i+1]<Level6)&&(Close[i+2]<Level6)&&(Open[i+2]<Level6)&&(Close[i+3]<Level6)&&(Open[i+3]<Level6)&&(Close[i+4]<Level6)&&(Open[i+4]<Level6)) qLevel6=Level6-EnterDw;  
      if ((Close[i+5]>Level7)&&(Open[i+5]>Level7)&&(Close[i]>Level7)&&(Open[i]>Level7)&&(Close[i+1]>Level7)&&(Open[i+1]>Level7)&&(Close[i+2]>Level7)&&(Open[i+2]>Level7)&&(Close[i+3]>Level7)&&(Open[i+3]>Level7)&&(Close[i+4]>Level7)&&(Open[i+4]>Level7)) qLevel7=Level7+EnterUP;  
      if ((Close[i+5]<Level7)&&(Open[i+5]<Level7)&&(Close[i]<Level7)&&(Open[i]<Level7)&&(Close[i+1]<Level7)&&(Open[i+1]<Level7)&&(Close[i+2]<Level7)&&(Open[i+2]<Level7)&&(Close[i+3]<Level7)&&(Open[i+3]<Level7)&&(Close[i+4]<Level7)&&(Open[i+4]<Level7)) qLevel7=Level7-EnterDw;  
      if ((Close[i+5]>Level8)&&(Open[i+5]>Level8)&&(Close[i]>Level8)&&(Open[i]>Level8)&&(Close[i+1]>Level8)&&(Open[i+1]>Level8)&&(Close[i+2]>Level8)&&(Open[i+2]>Level8)&&(Close[i+3]>Level8)&&(Open[i+3]>Level8)&&(Close[i+4]>Level8)&&(Open[i+4]>Level8)) qLevel8=Level8+EnterUP;  
      if ((Close[i+5]<Level8)&&(Open[i+5]<Level8)&&(Close[i]<Level8)&&(Open[i]<Level8)&&(Close[i+1]<Level8)&&(Open[i+1]<Level8)&&(Close[i+2]<Level8)&&(Open[i+2]<Level8)&&(Close[i+3]<Level8)&&(Open[i+3]<Level8)&&(Close[i+4]<Level8)&&(Open[i+4]<Level8)) qLevel8=Level8-EnterDw;  
      if ((Close[i+5]>Level9)&&(Open[i+5]>Level9)&&(Close[i]>Level9)&&(Open[i]>Level9)&&(Close[i+1]>Level9)&&(Open[i+1]>Level9)&&(Close[i+2]>Level9)&&(Open[i+2]>Level9)&&(Close[i+3]>Level9)&&(Open[i+3]>Level9)&&(Close[i+4]>Level9)&&(Open[i+4]>Level9)) qLevel9=Level9+EnterUP;  
      if ((Close[i+5]<Level9)&&(Open[i+5]<Level9)&&(Close[i]<Level9)&&(Open[i]<Level9)&&(Close[i+1]<Level9)&&(Open[i+1]<Level9)&&(Close[i+2]<Level9)&&(Open[i+2]<Level9)&&(Close[i+3]<Level9)&&(Open[i+3]<Level9)&&(Close[i+4]<Level9)&&(Open[i+4]<Level9)) qLevel9=Level9-EnterDw;  
      if ((Close[i+5]>Level10)&&(Open[i+5]>Level10)&&(Close[i]>Level10)&&(Open[i]>Level10)&&(Close[i+1]>Level10)&&(Open[i+1]>Level10)&&(Close[i+2]>Level10)&&(Open[i+2]>Level10)&&(Close[i+3]>Level10)&&(Open[i+3]>Level10)&&(Close[i+4]>Level10)&&(Open[i+4]>Level10)) qLevel10=Level10+EnterUP;  
      if ((Close[i+5]<Level10)&&(Open[i+5]<Level10)&&(Close[i]<Level10)&&(Open[i]<Level10)&&(Close[i+1]<Level10)&&(Open[i+1]<Level10)&&(Close[i+2]<Level10)&&(Open[i+2]<Level10)&&(Close[i+3]<Level10)&&(Open[i+3]<Level10)&&(Close[i+4]<Level10)&&(Open[i+4]<Level10)) qLevel10=Level10-EnterDw;  
   */   
Buffer1[i]=qLevel1;      
Buffer2[i]=qLevel2;      
Buffer3[i]=qLevel3;      
Buffer4[i]=qLevel4;      
Buffer5[i]=qLevel5;      
Buffer6[i]=qLevel6;      
Buffer7[i]=qLevel7;      
Buffer8[i]=qLevel8;      
Buffer9[i]=qLevel9;           
Buffer10[i]=qLevel10; 
//Buffer11[i]=LevelsVerticalShift;*/

 }
Comment(Level1[10]);
}
//----
   return(0);
   
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


//-----


void drawLine(string name, string dummy, string mydate, double price1, color col, int style, bool rayflag, int width)
{  


string time1=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59"));
string time2=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59")+86400);


if (TimeDayOfWeek(StrToTime(time1))==0) time1=TimeToStr(StrToTime(time1)+86400);
else if (TimeDayOfWeek(StrToTime(time1))==6) time1=TimeToStr(StrToTime(time1)+86400+86400);

if (TimeDayOfWeek(StrToTime(time2))==0) time2=TimeToStr(StrToTime(time2)+86400);
else if (TimeDayOfWeek(StrToTime(time2))==6) time2=TimeToStr(StrToTime(time2)+86400+86400);

if (reverse==true){
price1=correction*1/price1;



}

    if (ObjectFind(name) != 0) {
     ObjectDelete(name);
    } 
   ObjectCreate(name, OBJ_TREND, 0, StrToTime(time1), price1+LevelsVerticalShift, StrToTime(time2), price1+LevelsVerticalShift);
	ObjectSet(name, OBJPROP_COLOR, col);
	ObjectSet(name, OBJPROP_BACK, false);
	ObjectSet(name, OBJPROP_STYLE,style);
   ObjectSet(name, OBJPROP_RAY, rayflag);
   ObjectSet(name, OBJPROP_WIDTH, width);
           
}




void drawArea(string name, string mydate, double price1, double price2, color col, int style, bool rayflag, int width)
{  


string time1=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59"));
string time2=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59")+86400);

if (TimeDayOfWeek(StrToTime(time1))==0) time1=TimeToStr(StrToTime(time1)+86400);
else if (TimeDayOfWeek(StrToTime(time1))==6) time1=TimeToStr(StrToTime(time1)+86400+86400);

if (TimeDayOfWeek(StrToTime(time2))==0) time2=TimeToStr(StrToTime(time2)+86400);
else if (TimeDayOfWeek(StrToTime(time2))==6) time2=TimeToStr(StrToTime(time2)+86400+86400);

if (reverse==true){
price1=correction*1/price1;
price2=correction*1/price2;
}

    if (ObjectFind(name) != 0) {
     ObjectDelete(name);
    } 

   ObjectCreate(name, OBJ_RECTANGLE, 0, StrToTime(time1), price1+LevelsVerticalShift, StrToTime(time2), price2+LevelsVerticalShift);
	ObjectSet(name, OBJPROP_COLOR, col);
	ObjectSet(name, OBJPROP_BACK, true);
	ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSetText(name,"price2="+price2,10);
   
   ObjectCreate(name+"arrow",OBJ_ARROW,0,StrToTime(time1)+30,price1+LevelsVerticalShift);
   ObjectSet(name+"arrow",OBJPROP_ARROWCODE,arrowcode);
   ObjectSet(name+"arrow",OBJPROP_COLOR,KeyZoneArrowColor);
 
           
}